/* ScummVM - Scumm Interpreter
 * Copyright (C) 2001  Ludvig Strigeus
 * Copyright (C) 2001-2003 The ScummVM project 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Header: /cvsroot/scummvm/scummvm/scumm/boxes.h,v 1.3 2003/03/06 21:45:53 aquadran Exp $
 *
 */

#ifndef BOXES_H
#define BOXES_H

#define SIZEOF_BOX 20

typedef enum {
	kBoxXFlip		= 0x08,
	kBoxYFlip		= 0x10,
	kBoxPlayerOnly	= 0x20,
	kBoxLocked		= 0x40,
	kBoxInvisible	= 0x80
} BoxFlags;

struct AdjustBoxResult {	/* Result type of AdjustBox functions */
	int16 x, y;
	uint16 dist;
};

struct BoxCoords {			/* Box coordinates */
	ScummPoint ul;
	ScummPoint ur;
	ScummPoint ll;
	ScummPoint lr;
};

struct Box;
struct PathNode;
struct PathVertex;

#endif
